/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/10 10:10:06
 */

import { Component, html, raw } from 'wkit'

import createWebHashHistory from './hash-router.js'
import createWebHistory from './modern-router.js'

export { createWebHashHistory, createWebHistory }

class Router extends Component {
  static props = {
    keepAlive: false,
    current: 'str!'
  }

  #views = []

  created() {
    window.__wkitd__.set('ROUTER_VIEW', this)
  }

  sync(views) {
    this.#views = views
  }

  render() {
    if (this.keepAlive) {
      return html``
    } else {
      if (this.current) {
        return raw(`<${this.current}></${this.current}>`)
      }
    }
  }
}

if (!customElements.get('router-view')) {
  customElements.define('router-view', Router)
}

export function createRouter(
  { history = createWebHashHistory, routes = [] } = {},
  options
) {
  let $router = history(options)

  window.__wkitd__.set('$router', $router)
  Component.prototype.$router = $router

  $router.addRoute(routes)

  return function () {
    return $router
  }
}

export function getRouter() {
  return window.__wkitd__.get('$router')
}

export function getCurrentPage() {
  return getRouter().route
}
